<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Models\LaporanpelumasdetailsModel;
use App\Http\Base\BaseService;
use App\Http\Models\LaporanpelumasitemdetailsModel;
use App\Http\Models\LaporanpelumasModel;
use App\Http\Models\SystemparameterModel;
use App\Http\Models\ItemModel;

class LaporanpelumasdetailsService extends BaseService
{
	/**
     PelumasService constructor.
	 */
	public function __construct()
	{
		parent::__construct();
		$this->model = new LaporanpelumasdetailsModel();
		$this->penerimaanBarang = new PenerimaanbarangService();
		$this->penerimaanBarangIO = new PenerimaanbarangioService();
		$this->penggunaanBarang = new PenggunaanbarangService();
	}

	public function index()
	{
		return $this->model->getQuery()->get();
	}

	public function paging($request)
	{
		//
	}

	/**
	 *  get one raw row data from table by id
	 *  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	 *  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	 *  and you want to take value like this $model->fieldname
	 *  @param $id
	 *  @return LaporanpelumasdetailsModel
	 */
	public function show($request, $id)
	{
		$auth = json_decode($request->session()->get('auth'));

		$model = $this->model->getQuery()
			->where("Laporanpelumasdetails.id", "=", $id)->first();

		if ($model) {
			if ($model->tipe == "VOYAGE") { } else if ($model->tipe == "MONTH") { } else {
				$model = null;
			}
		}
		return $model;
	}

	public function showByMonth($reportID)
	{
		$model = (new LaporanpelumasdetailsModel())->joinRelationItemDetailsByMonth()->getQuery()
			->select([
				"laporanpelumasdetails.*",
				"itemdetails.transactionNo",
				"itemdetails.transactionDate",
				"itemdetails.pelabuhan",
				"itemdetails.qty",
				"itemdetails.detailId",
				"itemdetails.id AS itemDetailId",
			])
			->where("laporanpelumasdetails.reportId", "=", $reportID)
			->orderBy("laporanpelumasdetails.namaItem", "ASC")
			->orderBy("itemdetails.transactionDate", "ASC")
			->orderBy("itemdetails.transactionNo", "ASC")
			->get();
		return $model;
	}

	public function showByVoyage($reportID)
	{
		$model = $this->model->getQuery()
			->where("laporanpelumasdetails.reportId", "=", $reportID)
			->orderBy("laporanpelumasdetails.namaItem", "ASC")
			->get();

		foreach ($model as $idx => $row) {
			$model[$idx]->penerimaans = (new LaporanpelumasitemdetailsModel())->getQuery()->where("detailId", "=", $row->id)->orderBy("transactionDate", "ASC")->get();
		}
		return $model;
	}

	public function showByVoyageVer2($reportID)
	{
		$model = (new LaporanpelumasdetailsModel())->joinRelationItemDetails()->getQuery()
			->select([
				"laporanpelumasdetails.*",
				"itemdetails.transactionNo",
				"itemdetails.transactionDate",
				"itemdetails.pelabuhan",
				"itemdetails.qty",
				"itemdetails.detailId",
				"itemdetails.id AS itemDetailId",
			])
			->where("laporanpelumasdetails.reportId", "=", $reportID)
			->orderBy("laporanpelumasdetails.namaItem", "ASC")
			->orderBy("itemdetails.transactionDate", "ASC")
			->orderBy("itemdetails.transactionNo", "ASC")

			->get();
		return $model;
	}


	/**
	 *  this is a base function for storing data you with transaction by default
	 *  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	 *  @param array $input
	 *  @return LaporanpelumasdetailsModel
	 *  @throws \Exception
	 */
	public function store($input)
	{
		$jlhBarang = 0;
		if (isset($input["itemID"])) {
			$jlhBarang = array_sum($input["quantity"]);
		}
		$input["totalBarang"] = $jlhBarang;
		$input["locationId"] = 1;
		$input["type"] = 1;

		$transactionBrg = new LaporanpelumasdetailsModel();
		$transactionBrg->fill($input);
		if (!$transactionBrg->save()) {
			throw new \Exception();
		}
		return $transactionBrg->id;
	}


	/**
	 * this function will delete much data, in one action
	 * the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	 * you can remove this main alogorithm with your business requirement like soft delete or anything you want
	 *  @param $ids
	 */
	public function delete($ids)
	{
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	 *  this is a base function for update and delete data by default.
	 *  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	 *  you can add multiple relation proses after update in this function 
	 *  @param $id
	 *  @param array $input 
	 *  @return LaporanpelumasdetailsModel
	 *  @throws \Exception
	 */
	public function update($id, $input)
	{
		$pelumas = LaporanpelumasdetailsModel::find($id);
		$pelumas->fill($input);
		if (!$pelumas->update()) {
			throw new \Exception();
		}
		return $pelumas;
	}


	/**
	 *  this function will be confirting paging property into file excel
	 *  the main library is base on excel spreadsheet library
	 *  @param array $input
	 *   @return array|static[]
	 */
	public function exportToExcel($input = array())
	{
		return $this->model->getQuery()->get();
	}

	public function repopulateDataMonth($laporan)
	{
		// REPORT ID-> ID DARI ROW DATA (VOYAGE/MONTH)
		$reportID = $laporan->id;

		$sysParams = (new SystemparameterModel())->getQuery()->where("variableName", "=", "PELNIBBMPELUMAS")->first();
		$categoryPelumas = explode(";", $sysParams->variableValue)[1];
		$pelumasItems = (new ItemModel())->getQuery()->where("type_id", "=", $categoryPelumas)->where("enabled_flex", "=", "Y")->get();

		foreach ($pelumasItems as $pelumasItem) {

			$pelumasDetail = (new LaporanpelumasdetailsModel())->getQuery()
				->where("laporanpelumasdetails.itemId", "=", $pelumasItem->id)
				->where("laporanpelumasdetails.reportId", "=", $reportID)
				->first();

			if ($pelumasDetail) {
				$saldo_awal = $this->getPreviousSaldoAkhirBulan($laporan->tahun, $laporan->bulan, $pelumasItem->id);
				$pemakaian = $this->penggunaanBarang->getSumPenggunaanBarangBulan($pelumasItem->id, $laporan->tahun, $laporan->bulan);
				$totalPenerimaan = $this->repopulateDataItemBulan($pelumasItem->id, $laporan);
				$saldo_akhir = $saldo_awal + $totalPenerimaan - $pemakaian;

				$input = [
					"reportId" => $reportID,
					"itemId" => $pelumasItem->id,
					"saldo_awal" => $saldo_awal,
					"pemakaian" => $pemakaian,
					"saldo_akhir" => $saldo_akhir,
					"namaItem"  => $pelumasItem->namaItem,
					"deskripsi"  => $pelumasItem->deskripsi,
					"tahun" => $laporan->tahun,
					"bulan" => $laporan->bulan
				];

				$model = LaporanpelumasdetailsModel::find($pelumasDetail->id);
				$model->fill($input);
				if (!$model->update()) {
					throw new \Exception();
				}
				$detailID = $model->id;
			} else {
				$input = [
					"reportId" => $reportID,
					"itemId" => $pelumasItem->id,
					"saldo_awal" => 0,	// GANTI 0
					"pemakaian" => 0,	// GANTI 0
					"saldo_akhir" => 0,	// GANTI 0
					"namaItem"  => $pelumasItem->namaItem,
					"deskripsi"  => $pelumasItem->deskripsi,
					"tahun" => $laporan->tahun,
					"bulan" => $laporan->bulan
				];
				$model = new LaporanpelumasdetailsModel();
				$model->fill($input);
				if (!$model->save()) {
					throw new \Exception();
				}
				$detailID = $model->id;

				$model->saldo_awal = $this->getPreviousSaldoAkhirBulan($laporan->tahun, $laporan->bulan, $pelumasItem->id);
				$model->pemakaian = $this->penggunaanBarang->getSumPenggunaanBarangBulan($pelumasItem->id, $laporan->tahun, $laporan->bulan);
				$totalPenerimaan = $this->repopulateDataItemBulan($pelumasItem->id, $laporan);
				$model->saldo_akhir = $model->saldo_awal + $totalPenerimaan - $model->pemakaian;
				if (!$model->update()) {
					throw new \Exception();
				}
			}
		}
	}

	public function repopulateData($laporan)
	{
		// REPORT ID-> ID DARI ROW DATA (VOYAGE/MONTH)
		$reportID = $laporan->id;

		$sysParams = (new SystemparameterModel())->getQuery()->where("variableName", "=", "PELNIBBMPELUMAS")->first();
		$categoryPelumas = explode(";", $sysParams->variableValue)[1];

		$pelumasItems = (new ItemModel())->getQuery()->where("type_id", "=", $categoryPelumas)->where("enabled_flex", "=", "Y")->get();

		foreach ($pelumasItems as $pelumasItem) {

			$pelumasDetail = (new LaporanpelumasdetailsModel())->getQuery()
				->where("laporanpelumasdetails.itemId", "=", $pelumasItem->id)
				->where("laporanpelumasdetails.reportId", "=", $reportID)
				->first();

			if ($pelumasDetail) {

				$saldo_awal = $this->getPreviousSaldoAkhir($laporan->voyage_from, $pelumasItem->id);
				$pemakaian = $this->penggunaanBarang->getSumPenggunaanBarang($pelumasItem->id, $laporan->voyage_id, $laporan->voyage_from, $laporan->voyage_to);
				$totalPenerimaan = $this->repopulateDataItem($pelumasDetail->id, $pelumasItem->id, $laporan);
				$saldo_akhir = $saldo_awal + $totalPenerimaan - $pemakaian;

				$input = [
					"reportId" => $reportID,
					"itemId" => $pelumasItem->id,
					"saldo_awal" => $saldo_awal,
					"pemakaian" => $pemakaian,
					"saldo_akhir" => $saldo_akhir,
					"namaItem"  => $pelumasItem->namaItem,
					"deskripsi"  => $pelumasItem->deskripsi
				];

				$model = LaporanpelumasdetailsModel::find($pelumasDetail->id);
				$model->fill($input);
				if (!$model->update()) {
					throw new \Exception();
				}
				$detailID = $model->id;
			} else {
				$input = [
					"reportId" => $reportID,
					"itemId" => $pelumasItem->id,
					"saldo_awal" => 0,	// GANTI 0
					"pemakaian" => 0,	// GANTI 0
					"saldo_akhir" => 0,	// GANTI 0
					"namaItem"  => $pelumasItem->namaItem,
					"deskripsi"  => $pelumasItem->deskripsi
				];
				$model = new LaporanpelumasdetailsModel();
				$model->fill($input);
				if (!$model->save()) {
					throw new \Exception();
				}
				$detailID = $model->id;

				$model->saldo_awal = $this->getPreviousSaldoAkhir($laporan->voyage_from, $pelumasItem->id);
				$model->pemakaian = $this->penggunaanBarang->getSumPenggunaanBarang($pelumasItem->id, $laporan->voyage_id, $laporan->voyage_from, $laporan->voyage_to);
				$totalPenerimaan = $this->repopulateDataItem($detailID, $pelumasItem->id, $laporan);
				$model->saldo_akhir = $model->saldo_awal + $totalPenerimaan - $model->pemakaian;
				if (!$model->update()) {
					throw new \Exception();
				}
			}
		}
	}

	public function getPreviousSaldoAkhir($voyageFrom, $itemID)
	{
		$model = (new LaporanpelumasModel())->joinRelationPelumasDetails()->getQuery()
			->where("laporanpelumas.tipe", "=", "VOYAGE")
			->where("laporanpelumas.voyage_to", "<=", date("Y-m-d", strtotime($voyageFrom)))
			->where("laporanpelumasdetails.itemId", "=", $itemID)
			->orderBy("laporanpelumas.voyage_to", "DESC")
			->orderBy("laporanpelumas.voyage_from", "DESC")
			->first();
		if ($model) {
			return $model->saldo_akhir;
		} else {
			return 0;
		}
	}

	public function getPreviousSaldoAkhirBulan($tahun, $bulan, $itemID)
	{
		if ($bulan == 1) {
			$tahun--;
			$bulan = 12;
		} else {
			$bulan--;
		}
		$model = (new LaporanpelumasModel())->joinRelationPelumasDetails()->getQuery()
			->where("laporanpelumas.tipe", "=", "MONTH")
			->where("laporanpelumasdetails.tahun", "=", $tahun)
			->where("laporanpelumasdetails.bulan", "=", $bulan)
			->where("laporanpelumasdetails.itemId", "=", $itemID)
			->first();
		if ($model) {
			return $model->saldo_akhir;
		} else {
			return 0;
		}
	}

	public function repopulateDataItem($detailID, $itemID, $laporan)
	{
		// DETAIL ID-> REPORTID + ITEM ID
		$totalPenerimaan = 0;

		// select penerimaan BASED ON transaction date & itemID
		$penerimaans = []; // $this->penerimaanBarang->getItemPenerimaanBasedOnVoyage($itemID, $laporan->voyage_id, $laporan->voyage_from, $laporan->voyage_to);

		foreach ($penerimaans as $penerimaan) {
			// cek if available @ itemdetail

			$itemDetails = (new LaporanpelumasitemdetailsModel())->getQuery()
				->where("itemdetails.detailId", "=", $detailID)
				->where("itemdetails.transactionNo", "=", $penerimaan->receiptNumber)
				->first();

			$totalPenerimaan += $penerimaan->quantity;

			if ($itemDetails) {
				$input = [
					"detailId" => $detailID,
					"transactionDate" => $penerimaan->tanggalPenerimaan,
					"transactionNo" => $penerimaan->receiptNumber,
					"qty" => $penerimaan->quantity,
					"itemId" => $penerimaan->itemId,
					"tahun" => date("Y", strtotime($penerimaan->tanggalPenerimaan)),
					"bulan"	=> date("n", strtotime($penerimaan->tanggalPenerimaan))
				];

				$model = LaporanpelumasitemdetailsModel::find($itemDetails->id);
				$model->fill($input);
				if (!$model->update()) {
					throw new \Exception();
				}
			} else {
				$input = [
					"detailId" => $detailID,
					"transactionDate" => $penerimaan->tanggalPenerimaan,
					"transactionNo" => $penerimaan->receiptNumber,
					"qty" => $penerimaan->quantity,
					"itemId" => $penerimaan->itemId,
					"tahun" => date("Y", strtotime($penerimaan->tanggalPenerimaan)),
					"bulan"	=> date("n", strtotime($penerimaan->tanggalPenerimaan))
				];

				$model = new LaporanpelumasitemdetailsModel();
				$model->fill($input);
				$model->save();
			}
		}
		$totalPenerimaan = 0;
		$penerimaanIOs = $this->penerimaanBarangIO->getItemPenerimaanBasedOnVoyage($itemID, $laporan->voyage_id, $laporan->voyage_from, $laporan->voyage_to);
		foreach ($penerimaanIOs as $penerimaanIO) {
			// cek if available @ itemdetail

			$itemDetails = (new LaporanpelumasitemdetailsModel())->getQuery()
				->where("itemdetails.detailId", "=", $detailID)
				->where("itemdetails.transactionNo", "=", $penerimaanIO->rcNumber)
				->first();

			$totalPenerimaan += $penerimaanIO->quantity;

			if ($itemDetails) {
				$input = [
					"detailId" => $detailID,
					"transactionDate" => $penerimaanIO->tanggalPenerimaan,
					"transactionNo" => $penerimaanIO->rcNumber,
					"qty" => $penerimaanIO->quantity,
					"itemId" => $penerimaanIO->itemId,
					"tahun" => date("Y", strtotime($penerimaanIO->tanggalPenerimaan)),
					"bulan"	=> date("n", strtotime($penerimaanIO->tanggalPenerimaan))
				];

				$model = LaporanpelumasitemdetailsModel::find($itemDetails->id);
				$model->fill($input);
				if (!$model->update()) {
					throw new \Exception();
				}
			} else {
				$input = [
					"detailId" => $detailID,
					"transactionDate" => $penerimaanIO->tanggalPenerimaan,
					"transactionNo" => $penerimaanIO->rcNumber,
					"qty" => $penerimaanIO->quantity,
					"itemId" => $penerimaanIO->itemId,
					"tahun" => date("Y", strtotime($penerimaanIO->tanggalPenerimaan)),
					"bulan"	=> date("n", strtotime($penerimaanIO->tanggalPenerimaan))
				];

				$model = new LaporanpelumasitemdetailsModel();
				$model->fill($input);
				$model->save();
			}
		}
		return $totalPenerimaan;
	}

	public function repopulateDataItemBulan($itemID, $laporan)
	{
		// DETAIL ID-> REPORTID + ITEM ID
		$totalPenerimaan = 0;

		$itemDetails = (new LaporanpelumasitemdetailsModel())->getQuery()
			->where("itemdetails.itemId", "=", $itemID)
			->where("itemdetails.tahun", "=", $laporan->tahun)
			->where("itemdetails.bulan", "=", $laporan->bulan)
			->get();

		foreach ($itemDetails as $itemDetail) {
			$totalPenerimaan += $itemDetail->qty;
		}
		return $totalPenerimaan;
	}
}
